// BitmapInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BitmapViewer.h"
#include "BitmapInfoDlg.h"

#include "Dib\Dib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitmapInfoDlg dialog


CBitmapInfoDlg::CBitmapInfoDlg( CDib* pDib, LPCTSTR szFileName,
			CWnd* pParent /*=NULL*/)
	: CDialog(CBitmapInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBitmapInfoDlg)
	m_nBitsPerPixel = 0;
	m_nColorTableSize = 0;
	m_strFileName = _T("");
	m_nHeight = 0;
	m_nWidth = 0;
	//}}AFX_DATA_INIT

	if ( pDib->IsValid() ) {
		m_strFileName = szFileName;
		m_nBitsPerPixel = pDib->GetBitsPerPixel();
		m_nColorTableSize = pDib->GetColorTableSize();
		m_nWidth = pDib->GetWidth();
		m_nHeight = pDib->GetHeight();
	}
}


void CBitmapInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBitmapInfoDlg)
	DDX_Text(pDX, IDC_BITS_PER_PIXEL, m_nBitsPerPixel);
	DDX_Text(pDX, IDC_COLOR_TABLE_SIZE, m_nColorTableSize);
	DDX_Text(pDX, IDC_FILE_NAME, m_strFileName);
	DDX_Text(pDX, IDC_HEIGHT, m_nHeight);
	DDX_Text(pDX, IDC_WIDTH, m_nWidth);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBitmapInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CBitmapInfoDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitmapInfoDlg message handlers
