////////////////////////////////////////////////////////////////////////////////
//
//  BitmapViewerDoc.h
//
//  This source file is a supplement to the article "Windows i Bitmape".
//  The article was published in the #23 and #25 issues of the "PC" computer
//  monthly, published in Belgrade, Yugoslavia by "PC Press"
//
//  You can freely use, modify and redistribute this file, provided that
//  this header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////

// BitmapViewerDoc.h : interface of the CBitmapViewerDoc class
//
/////////////////////////////////////////////////////////////////////////////

#include "Dib\Dib.h"

class CBitmapViewerDoc : public CDocument
{
protected: // create from serialization only
	CBitmapViewerDoc();
	DECLARE_DYNCREATE(CBitmapViewerDoc)

// Attributes
public:
	CDib* GetBitmap();
	CPalette* GetPalette();

	enum UpdateHints {
		UPDATE_ONLY,
		REFIT_AND_UPDATE
	};

// Operations
public:
	void UpdateAllDocs();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBitmapViewerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBitmapViewerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBitmapViewerDoc)
	afx_msg void OnConvertto1bpp();
	afx_msg void OnUpdateConvertto1bpp(CCmdUI* pCmdUI);
	afx_msg void OnConvertto4bpp();
	afx_msg void OnUpdateConvertto4bpp(CCmdUI* pCmdUI);
	afx_msg void OnConvertto8bpp();
	afx_msg void OnUpdateConvertto8bpp(CCmdUI* pCmdUI);
	afx_msg void OnConvertto16bpp();
	afx_msg void OnUpdateConvertto16bpp(CCmdUI* pCmdUI);
	afx_msg void OnConvertto24bpp();
	afx_msg void OnUpdateConvertto24bpp(CCmdUI* pCmdUI);
	afx_msg void OnConvertto32bpp();
	afx_msg void OnUpdateConvertto32bpp(CCmdUI* pCmdUI);
	afx_msg void OnFileInfoaboutbitmap();
	afx_msg void OnUpdateFileInfoaboutbitmap(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

//	internals:
protected:
	CDib* m_pBitmap;
	CPalette* m_pBitmapPalette;
};

/////////////////////////////////////////////////////////////////////////////
