////////////////////////////////////////////////////////////////////////////////
//
//  BitmapViewerView.h
//
//  This source file is a supplement to the article "Windows i Bitmape".
//  The article was published in the #23 and #25 issues of the "PC" computer
//  monthly, published in Belgrade, Yugoslavia by "PC Press"
//
//  You can freely use, modify and redistribute this file, provided that
//  this header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////

// BitmapViewerView.h : interface of the CBitmapViewerView class
//
/////////////////////////////////////////////////////////////////////////////

class CBitmapViewerView : public CScrollView
{
protected: // create from serialization only
	CBitmapViewerView();
	DECLARE_DYNCREATE(CBitmapViewerView)

// Attributes
public:
	CBitmapViewerDoc* GetDocument();

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBitmapViewerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBitmapViewerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void RefitToBitmap();

// Generated message map functions
protected:
	//{{AFX_MSG(CBitmapViewerView)
	//}}AFX_MSG
	afx_msg LRESULT OnRealizePalette(WPARAM wParam, LPARAM lParam);  // user message

	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BitmapViewerView.cpp
inline CBitmapViewerDoc* CBitmapViewerView::GetDocument()
   { return (CBitmapViewerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
