////////////////////////////////////////////////////////////////////////////////
//
//  DibUt.h
//
//  This source file is a supplement to the article "Windows i Bitmape".
//  The article was published in the #23 and #25 issues of the "PC" computer
//  monthly, published in Belgrade, Yugoslavia by "PC Press"
//
//  You can freely use, modify and redistribute this file, provided that
//  this header is kept unchanged
//
//                                                                 Ivica Nikolic
//                                                      ivica@galeb.etf.bg.ac.yu
//
////////////////////////////////////////////////////////////////////////////////



//
//  This header file contains declaratins of various utility functions which
//  operate upon DIBs. In order to restrict namespace pollution, they are all
//  declared as static member functions of the CDibUt ("Dib utilities") class.
//  This is recommended practice for creating groups of functions whose main
//  purpose is to "chew" raw bitmap data - group all functions that are focused
//  on same aspect of DIB usage (e.g. digital image processing) in single class
//  utility, or family of related utilities at different levels of abstraction
//

#if !defined(__DIB_UT_H)
#define __DIB_UT_H

#if !defined(__DIB_H)
	#include "Dib.h"
#endif // __DIB_H

////////////////////////////////////////////////////////////////////////////
// CDibUt
//

class CDibUt
{
public:
	static BOOL CanConvertToBpp( CDib* pdibSrc, int nBpp );

	static void ConvertTo32Bpp( CDib* pdibSrc, CDib* pdibDst );
	static void ConvertTo24Bpp( CDib* pdibSrc, CDib* pdibDst );
	static void ConvertTo16Bpp( CDib* pdibSrc, CDib* pdibDst );
	static void ConvertTo8Bpp( CDib* pdibSrc, CDib* pdibDst );
	static void ConvertTo4Bpp( CDib* pdibSrc, CDib* pdibDst );
	static void ConvertTo1Bpp( CDib* pdibSrc, CDib* pdibDst );

	static void SplitRGBChannels( CDib* pdibSrc, CDib* pdibDstB, CDib* pdibDstG,
		CDib* pdibDstR );
	static void CombineRGBChannels( CDib* pdibSrcB, CDib* pdibSrcG,
		CDib* pdibSrcR, CDib* pdibDst, int nDstBitsPerPixel );
};

#endif // __DIB_UT_H
